<?php
// Pull in the NuSOAP code
require_once('nusoap.php');
// Create the server instance
$server = new soap_server();
// Initialize WSDL support
$server->configureWSDL('StockQuote', 'urn:StockQuoteWSDL');
// Put the WSDL schema types in the namespace with the tns prefix
$server->wsdl->schemaTargetNamespace = 'urn:StockQuoteWSDL';
// Register the data structures used by the service
$server->wsdl->addComplexType(
    'region',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'region' => array('name'=>'region','type'=>'xsd:string'),
        'code' => array('name'=>'code','type'=>'xsd:string')
    )
);
$server->wsdl->addComplexType(
    'regionArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:region[]')
    ),
    'tns:region'
);
// Register the method to expose
$server->register(
	// method name
	'StockQuote',

	// input parameters						
	array('stockno' => 'xsd:string','region' => 'xsd:string'),
		
	// output parameters
	array('lastprice' => 'xsd:float','datetime' => 'xsd:string','volume' => 'xsd:string'),					

	// namespace
	'urn:StockQuoteWSDL',						

	// soapaction
	'urn:StockQuoteWSDL#region',                
	
	// style
	'rpc', 
                        
	// use
	'encoded',   
                         
	// documentation
	'Stock Quote from Yahoo'            
);
$server->register(
	// method name
	'RegionList',

	// input parameters						
	array(),
		
	// output parameters
	array('return' => 'tns:regionArray'),	

	// namespace
	'urn:StockQuoteWSDL',						

	// soapaction
	'urn:StockQuoteWSDL#quote',                
	
	// style
	'rpc', 
                        
	// use
	'encoded',   
                         
	// documentation
	'Region List from Yahoo'            
);
// Define the method as a PHP function
function StockQuote($stockno, $region) {
	if($stockno == ''){
		return new soap_fault('Client','','Must supply a valid stock no/symbol.');
	}
	$fd = fopen("http://hk.finance.yahoo.com/d/quotes.csv?f=sl1d1t1c1ohgv&e=.csv&s=".$stockno."&m=".$region, "r");
	if($fd) while(!feof($fd)) $fpage = $fpage . fread($fd, 1024);
	$resultA = split(",", $fpage);
	fclose($fd);
	return array(
		'last' => $resultA[1],
                'datetime' => str_replace("\"","",$resultA[2])." ".str_replace("\"","",$resultA[3]),
		'volume' => $resultA[8]
        );
}
function RegionList(){
	$fd = fopen("http://hk.finance.yahoo.com/", "r");
	if($fd) while(!feof($fd)) $fpage = $fpage . fread($fd, 1024);
	preg_match("'<select[^>]*>.*?</select>'si", $fpage, $match);

	$search = array("'\n</select>'", "'<select[^>]*?>\n'", "'<.*>'", "'\(.*\)'");
	$replace = array("","","","");

	$regionA = iconv("Big5", "UTF-8", preg_replace($search, $replace, $match[0]));
	$region = split("\n", $regionA);

	$search = array("'\n</select>'", "'<select[^>]*?>\n'", "' selected'", "'<option value='", "'>.*'");
	$replace = array("","","","","");

	$codeA = preg_replace($search, $replace, $match[0]);
	$code = split("\n", $codeA);
	
	$regionlist = array();
	for ($i=0;$i<count($region);$i++) array_push($regionlist, array('code' => $code[$i],'region' => $region[$i]));

	return $regionlist;
}
// Use the request to (try to) invoke the service
$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);
?>